def pre_request(worker, req):
    # Default:
    #   def pre_request(worker, req):
    #       worker.log.debug("%s %s" % (req.method, req.path))
    # Override needed in order to avoid log duplicates
    pass


def worker_abort(worker):
    pid = worker.pid
    worker.log.info("Worker with PID {} is being killed".format(pid))

    # Get traceback info
    import threading, sys, traceback  # noqa: E401
    id2name = {th.ident: th.name for th in threading.enumerate()}
    code = []
    for threadId, stack in sys._current_frames().items():
        code.append("\n# Thread: %s(%d)" % (id2name.get(threadId, ""), threadId))
        for filename, lineno, name, line in traceback.extract_stack(stack):
            code.append('File: "%s", line %d, in %s' % (filename, lineno, name))
            if line:
                code.append("  %s" % (line.strip()))
    worker.log.info("\n".join(code))
