from core.encoder import ComplexEncoder
from models.request_context import RequestContext
from models.user_context import UserContext


class ContextHeaders(object):
    def __init__(self,
                 user_context=None,
                 request_context=None):
        self.user_context = user_context or UserContext()
        self.request_context = request_context or RequestContext()

    def json(self):
        return ComplexEncoder().encode(self)

    @staticmethod
    def parse(json):
        context_headers = ContextHeaders(
            user_context=UserContext.parse(json),
            request_context=RequestContext.parse(json)
        )
        return context_headers
