from core.encoder import ComplexEncoder


class OrgContext(object):
    def __init__(self):
        self.org_id = None
        self.user_id = None
        self.user_name = None
        self.org_key = None
        self.connector_id = None
        self.rbac_key = None

    def json(self):
        return ComplexEncoder().encode(self)

    @staticmethod
    def parse(json):
        ctx = OrgContext()
        ctx.org_id = json['org_id']
        ctx.user_id = json['user_id']
        ctx.user_name = json['user_name']
        ctx.org_key = json['org_key']
        ctx.connector_id = json['connector_id']
        ctx.rbac_key = json['rbac_key']
        return ctx


class UserContext(object):
    def __init__(self):
        self.login_org = OrgContext()
        self.target_org = OrgContext()

    def json(self):
        return ComplexEncoder().encode(self)

    def rate_org_id(self):
        try:
            return int(self.target_org.org_id)
        except:
            pass
        try:
            return int(self.login_org.org_id)
        except:
            pass
        return 0

    @staticmethod
    def parse(json):
        ctx = UserContext()
        ctx.login_org.__dict__ = json['user_context']['login_org']
        ctx.target_org.__dict__ = json['user_context']['target_org']
        return ctx
